--   Programming Language Technology:
--   Putting Formal Languages to Work
--
--   Andreas Abel, 16 May 2016
--
-- Guest lecture in class
--
--   Finite Automata Theory and Formal Languages
--   TMV027/DIT321, LP4 2016
--   http://www.cse.chalmers.se/edu/course/TMV027/

-- Calculator main program.

import Control.Monad (unless)

import CalcLexer  (alexScanTokens)
import CalcParser (calcParser)

-- Main loop.  While line not empty:
-- read line from console,
-- parse it as arithmetical expression and
-- print its calculated value.

main :: IO ()
main = do
  s <- getLine
  unless (null s) $ do
    print (calcParser (alexScanTokens s))
    main
